program animera_mera;
uses crt,graph;

type dot = record
             x,y,z:real;
           end;

const persp = 0.998;
      colconst:array[0..15] of byte =
              (0,1,2,3,4,5,20,7,56,57,58,59,60,61,62,63);

var perspektiv:real;
    c,s:array[0..359] of real;

(***************************************************************************)
(*****                                                                 *****)
(*****                  TYPDEKLARATION TILL FIGUR                      *****)
(*****                                                                 *****)
(***************************************************************************)

type figurpek = ^figur;
     figur = object
       xr,yr,zr:word;	{rotations variabler}
       x,y,z:integer; 	{positions variabler}
       procedure rotate3D(var p:dot);	{roterar punkten p's koordinater}
       procedure djup(var punkt:dot);	{ger absolutkoordinaterna till p}
       procedure move(tx,ty,tz:integer);	{flyttar till tx,ty,tz}
       procedure rotate(txr,tyr,tzr:word);	{ndrar xr,yr,zr med txr,tyr,tzr}
       procedure rotateto(txr,tyr,tzr:word);	{ndrar xr,yr,zr till txr,tyr,tzr}
       procedure draw(page:byte); virtual;  	{ritar figuren p sida page}
     end;

(****************************************************************************)
(*****                                                                  *****)
(*****                     TYPDEKLARATION TILL KUB                      *****)
(*****                                                                  *****)
(****************************************************************************)


{Interface:   constructor init(tx,ty,tz:integer; txr,tyr,tzr:word);
              procedure move(tx,ty,tz:integer);
              procedure rotate(txr,tyr,tzr:word);
              procedure rotateto(txr,tyr,tzr:word);
              procedure draw(page:byte); virtual;
              destructor done;}


type dots = array[1..8] of dot;
     sidtyp = record
                corners:array[1..4] of byte;
                xr,yr:integer;
              end;
     sidortyp = array[1..6] of sidtyp;
     polytyp = array[1..4] of record x,y:integer; end;
     kubpek = ^kub;
     kub = object(figur)

       oldpoly:array[0..1,1..6] of record
                                     visual:boolean;
                                     poly:polytyp;
                                   end;
                          {De sparade vrdena p sidornas absoluta
                           koordinater fr de olika sidorna (0 och 1)}
       constructor init(tx,ty,tz:integer; txr,tyr,tzr:word);
       procedure draw(page:byte); virtual;
       destructor done;
     end;


(****************************************************************************)
(*****                                                                  *****)
(*****                     IMPLEMENTATION AV FIGUR                      *****)
(*****                                                                  *****)
(****************************************************************************)

procedure figur.rotate3D(var p:dot);
var tx,ty,tz:real;
begin
  tx:=p.x*(c[yr]*c[zr]+s[xr]*s[yr]*s[zr])-p.y*c[xr]*s[zr]
           +p.z*(-s[yr]*c[zr]+s[xr]*c[yr]*s[zr]);
  ty:=p.x*(c[yr]*s[zr]-s[xr]*s[yr]*c[zr])+p.y*c[xr]*c[zr]
           -p.z*(s[yr]*s[zr]+s[xr]*c[yr]*c[zr]);
  tz:=p.x*c[xr]*s[yr]+p.y*s[xr]+p.z*c[xr]*c[yr];
  p.x:=tx;
  p.y:=ty;
  p.z:=tz;
end;

procedure figur.djup(var punkt:dot);
begin
  punkt.x:=punkt.x+x;
  punkt.y:=punkt.y+y;
  punkt.z:=punkt.z+z;
  punkt.x:=punkt.x/exp(punkt.z*perspektiv)*470/350;
  punkt.y:=punkt.y/exp(punkt.z*perspektiv);
end;

procedure figur.move(tx,ty,tz:integer);
begin
  x:=tx;
  y:=ty;
  z:=tz;
end;

procedure figur.rotate(txr,tyr,tzr:word);
begin
  xr:=(xr+txr) mod 360;
  yr:=(yr+tyr) mod 360;
  zr:=(zr+tzr) mod 360;
end;

procedure figur.rotateto(txr,tyr,tzr:word);
begin
  xr:=txr;
  yr:=tyr;
  zr:=tzr;
end;

procedure figur.draw(page:byte);
begin
end;



(****************************************************************************)
(*****                                                                  *****)
(*****                      IMPLEMENTATION AV KUB                       *****)
(*****                                                                  *****)
(****************************************************************************)

constructor kub.init(tx,ty,tz:integer; txr,tyr,tzr:word);
begin
  x:=tx;
  y:=ty;
  z:=tz;
  xr:=txr;
  yr:=tyr;
  zr:=tzr;
  fillchar(oldpoly,194,0);
end;


procedure kub.draw(page:byte);
var count1,count2:byte;
    poly:array[1..6] of polytyp;
    col:real;
    dotmatrix:dots;

const defdots:dots =(              {Kubens ursprugs koordinater}
        (x:-50;y: 50;z: 50),
        (x: 50;y: 50;z: 50),
        (x:-50;y:-50;z: 50),
        (x: 50;y:-50;z: 50),
        (x:-50;y: 50;z:-50),
        (x: 50;y: 50;z:-50),
        (x:-50;y:-50;z:-50),
        (x: 50;y:-50;z:-50));


      sidor:sidortyp =(
        (corners:(1,2,4,3); xr:  0; yr:  0),  {Talar om vilka koordinater}
        (corners:(5,6,8,7); xr:  0; yr:180),  {som ingr i de respektive}
        (corners:(1,2,6,5); xr:270; yr: -1),  {sidorna}
        (corners:(3,4,8,7); xr: 90; yr: -1),
        (corners:(2,4,8,6); xr:  0; yr:270),
        (corners:(1,3,7,5); xr:  0; yr: 90));

begin
  setactivepage(page);
  dotmatrix:=defdots;
  for count1:=1 to 8 do begin      {berknar absoluta koordinater}
    rotate3d(dotmatrix[count1]);
    djup(dotmatrix[count1]);
  end;

  setcolor(0);
  setfillstyle(solidfill,0);        {Suddar ut de sidor som ritades ut
                                     frra gngen}
  for count1 :=1 to 6 do if oldpoly[page,count1].visual then begin
    fillpoly(4,oldpoly[page,count1].poly);
  end;

  for count1:=1 to 6 do begin     {berknar frg och om sidan r synlig}
    col:=1;
    if sidor[count1].xr>-1 then col:=col*c[(sidor[count1].xr+xr) mod 360];
    if sidor[count1].yr>-1 then col:=col*c[(sidor[count1].yr+yr) mod 360];
    if col>0.1 then begin
      oldpoly[page,count1].visual:=true;
      for count2:=1 to 4 do begin     {omvandlar till fillpoly format}
        poly[count1,count2].x:=round(dotmatrix[sidor[count1].corners[count2]].x);
        poly[count1,count2].y:=round(dotmatrix[sidor[count1].corners[count2]].y);
      end;
      setfillstyle(solidfill,trunc(col*15)+1);
      fillpoly(4,poly[count1]);
      oldpoly[page,count1].poly:=poly[count1];
    end else oldpoly[page,count1].visual:=false;
  end;
end;

destructor kub.done;
begin
end;

(****************************************************************************)
(*****                       Procedure Init                             *****)
(*****                       --------------                             *****)
(*****            Initierar grafiken, gr sinus/cosinus tabell          *****)
(*****                         stter paletten,                         *****)
(*****          lgger skrmkoordinaternas origo mitt p skrmen        *****)
(****************************************************************************)

procedure init;
var a,d,m:integer;
begin
  d:=ega;
  m:=egahi;
  initgraph(d,m,'c:\tp');
  perspektiv:=ln(persp);
  for a:=1 to 15 do setrgbpalette(colconst[a],{a*4+3}20,{a*4+3}5,a*4+3);
  setviewport((getmaxx div 2),(getmaxy div 2),
                        (getmaxx div 2),(getmaxy div 2),clipoff);
  for a:=0 to 359 do begin
    c[a]:=cos(a*pi/180);
    s[a]:=sin(a*pi/180);
  end;
end;





(****************************************************************************)
(*****                                                                  *****)
(*****                           HUVUDPROGRAM                           *****)
(*****                                                                  *****)
(****************************************************************************)

var page:byte;
    cube:kubpek;

begin
  init;
  page:=0;
  new(cube,init(0,0,0,0,0,0));
  repeat
    cube^.rotate(1,2,3);
    setvisualpage(page);
    page:=page xor 1;
    cube^.draw(page);
  until keypressed;
  closegraph;
  dispose(cube,done);
end.